--Stance Module

--allows bars to become completely invisible, unless the player is in a certain stance.

--[[This Module needs a complete re-write as a lot of classes have lost their stances now

	In fact: Even looking at a class where stances still exist - the warden - it is really messed up with no stance at position "1" etc.
	
	--NASTY HACK Around line 81 for Minstrel; the names of the stances.
	
	]]

--Idea; plugin to the option window and load functions, then it should just run itself!
import "Turbine.Gameplay.Attributes"
import "Turbine.Gameplay";

--[[To do;

		Note: If you have just dropped the stance when you load Bevy it can get the flag the wrong way around!

Notes:
	PlayerAttributes:GetStance() gets the current stance as an index. The stances table contains these in order
	Player:GetClass() gets the current player class as an index. The classes table contains these in order.
	
	Classes table (in english - if I use the indexes then it should not be an issue in other languages. I hope)
	
	194 - Warden is missing from the table!
	
	
	162: Hunter!					
	172: Champion!
	23: Guardian!
	31: Minstrel!
	40: Burglar!
	194: Warden
	185: LoreMaster
	193: RuneKeeper
	24: Captain
]]--

function initialisestance()
	--Set up a watch for stances
	--Extract available stances
		local classtable=nil
			--Detect which table to load
				if 	PlayerClass==Turbine.Gameplay.Class.BlackArrow 	then classtable=Turbine.Gameplay.Attributes.BlackArrowStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Burglar 	then classtable=Turbine.Gameplay.Attributes.BurglarStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Captain 	then classtable=Turbine.Gameplay.Attributes.CaptainStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Champion 	then classtable=Turbine.Gameplay.Attributes.ChampionStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Chicken 	then classtable=Turbine.Gameplay.Attributes.ChickenStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Defiler 	then classtable=Turbine.Gameplay.Attributes.DefilerStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Guardian 	then classtable=Turbine.Gameplay.Attributes.GuardianStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Hunter 		then classtable=Turbine.Gameplay.Attributes.HunterStance end
				if 	PlayerClass==Turbine.Gameplay.Class.LoreMaster 	then classtable=Turbine.Gameplay.Attributes.LoreMasterStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Minstrel 	then classtable=Turbine.Gameplay.Attributes.MinstrelStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Ranger 		then classtable=Turbine.Gameplay.Attributes.RangerStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Reaver 		then classtable=Turbine.Gameplay.Attributes.ReaverStance end
				if 	PlayerClass==Turbine.Gameplay.Class.RuneKeeper 	then classtable=Turbine.Gameplay.Attributes.RuneKeeperStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Stalker 	then classtable=Turbine.Gameplay.Attributes.StalkerStance end
				if 	PlayerClass==Turbine.Gameplay.Class.WarLeader 	then classtable=Turbine.Gameplay.Attributes.WarLeaderStance end
				if 	PlayerClass==Turbine.Gameplay.Class.Weaver 		then classtable=Turbine.Gameplay.Attributes.WeaverStance end
				
				--Unload if the table is nil
				if classtable==nil or type(classtable)~="table" then 
					ColorWrite(0.5,0.5,0.5,"No stances for this class! Warning! Module disabled!")
					Modules.stance=nil
					if Modulestance~=nil then Modulestance:SetChecked(false) end 
					return
				end
				
				local count = 0
				for _ in pairs(classtable) do count = count + 1 end
				
				if count<2 then ColorWrite(1,0,0,"I suspect that turbine has changed this class to not have stances anymore. I suggest disabling the stance module if this is true") end
				
			--Stances will contain a table, indexed by PlayerAttribute:GetStance() that gives the stance in text.
			--These names are completely messed up for a lot of classes now.
			--Individual fixes possibly?
			
			stances={}
			
			local maxi=0 --PART OF NASTY HACK!
			for i,v in pairs(classtable) do 
				if type(v)~="function" then	--What is "isA"?
					stances[v]=i 
					--ColorWrite(0.5,0.5,0.5,"Stance detected: "..i.." at index "..v) --Here for debugging purposes
					if v>maxi then maxi=v end --PART OF NASTY HACK!
				end
			end
			
			--NASTY HACK!
			--OK - individual name fix for the Minstrel
			if 	PlayerClass==31 	then
				stances[0]="Melody"
				stances[1]="Dissonance"
				stances[2]="Resonance"
			end
			
			--NASTY HACK! Some stances are missing; for example Guardians Threat. This scans through the file and puts the Number of the stance where the name should be if blank.
			for i=0,maxi do
				if stances[i]==nil then stances[i]="Stance name missing Turbine! "..i end
			end

	stancewatcher()
	stanceupdate()
	
	if stanceinserted==nil then
	stanceinserted=true
	table.insert(Context,
	function (self,contextMenu,contextMenuItems)
	--Add the "Stance Bar" option to every Bar.
		local StanceBar = Turbine.UI.MenuItem( "Stance must be:");
			contextMenu.Stances = StanceBar:GetItems()
			
			local val=nil
			local stanceMenu={}
			for i=0,#stances do
				if self.Data.stance==nil then val=false else val=self.Data.stance[i] end
					stanceMenu[i] = Turbine.UI.MenuItem( stances[i],true,val );
					stanceMenu[i].Click = function( sender, args )
						if self.Data.stance==nil then self.Data.stance={} end
						self.Data.stance[i]=not(self.Data.stance[i])
						checkstances(self)
						stanceupdate()
						stancewatcher()
					end
				contextMenu.Stances:Add(stanceMenu[i])		
			end
			--Option to show in ALL stances
				stanceMenu[99] = Turbine.UI.MenuItem( "Show in all stances");
					stanceMenu[99].Click = function( sender, args )
						self.Data.stance=nil
						stancewatcher()
					end
				contextMenu.Stances:Add(stanceMenu[99])		
			
		contextMenuItems:Add( StanceBar )
	end)

	table.insert(Opt.Module,
		function()

		Opt.StanceBox=CollapseBox("Stance Options","f",1,true)
		
		Opt.ListBox:AddItem(Opt.StanceBox)
		
		table.insert(Opt.source,"stance")
		Opt.table.stance=true
		
		Opt.stance=Dummy()
		
		local count=1
		
		Opt.StanceCheck={}
		
		for index,v in pairs(stances) do --index index v description
			Opt.StanceCheck[index]=Opt.CheckBox(v,function(k,i)
				if Bar[i].Data.stance==nil then Bar[i].Data.stance={} end
					Bar[i].Data.stance[index]=k
					checkstances(Bar[i])
					stanceupdate()
					stancewatcher()
					
					Opt.Update()
			end)
			
			Opt.StanceBox.Content:AddItem(Opt.StanceCheck[index])
		end	
		
		Opt.StanceClear=Turbine.UI.Lotro.Button()
		Opt.StanceClear:SetText("Show in all stances")
		Opt.StanceClear.MouseDown=function() 
			for i=1,#Bar do
				if Bar[i].delete==false then
					if Bar[i].Checked then
						Bar[i].Data.stance=nil
						Bar[i]:Show()
					end
				end
			end
			stancewatcher()
			Opt.Update()
		end
		Opt.StanceBox.Content:AddItem(Opt.StanceClear)

		end)

	table.insert(Opt.Updaters, 
		function()
			if Opt.StanceCheck~=nil then
				local k=false
				
				for index,v in pairs(stances) do
					
					Opt.StanceCheck[index]:SetBackColor(nil)
					
					if Opt.tab.stance[index] then 
						Opt.StanceCheck[index]:SetVal(true) 
					else
						Opt.StanceCheck[index]:SetVal(false) 
					end
					
					if Opt.Check.stance[index] then Opt.StanceCheck[index]:SetBackColor(Turbine.UI.Color(1,0.3,0.3,0.3)) end
				end
			end
		end)
	end
	
end

function stancewatcher()
	--Watch for stance change
	--Add/remove a callback for each bar
	for i=1,#Bar do
		if Bar[i].Data.stance~=nil then	
			Bar[i].Callback.SC=function() Bar[i]:StanceChanged() end
			AddCallback(PlayerAttributes,"StanceChanged",Bar[i].Callback.SC)
		else
			RemoveCallback(PlayerAttributes,"StanceChanged",Bar[i].Callback.SC)
		end
	end

end

function NewBar:StanceChanged()

	if self.Data.stance==nil then return end
	
	local currentstance=PlayerAttributes:GetStance()

	if self.Data.stance[currentstance] then
		self.InStance=true
		self:Show()
		if Proc then procupdate() end
	else
		self.InStance=false
		self:Hide()
	end
end

function stanceupdate()
	--Scans every bar - used when the screen is locked/unlocked
	for i=1,#Bar do
		if Bar[i].Data.stance~=nil then	Bar[i]:StanceChanged()	end
	end
end

function checkstances(self)
--if all of the items of a stance list are nil then set the whole thing to nil
	if self.Data.stance~=nil then
		for j=0,#stances do
			if self.Data.stance[j] then return end
		end
	end
	self.Data.stance=nil
end

initialisestance()